import QtQuick 2.7

import Qt3D.Core 2.0
import Qt3D.Render 2.0
import Qt3D.Input 2.0
import Qt3D.Extras 2.0
import QtQuick.Scene3D 2.0

Entity {
    id: root

    property real r: 0
    property real phi: 0

    property var matrix
    property var brect
    property var scaledMatrix: root.matrix.times(root.scaleBrect)

    property matrix4x4 rotX90: Qt.matrix4x4(1, 0,  0, 0,
                                            0, 0, -1, 0,
                                            0, 1,  0, 0,
                                            0, 0,  0, 1)

    property matrix4x4 scaleBrect: Qt.matrix4x4(brect.width,            0, 0, 0,
                                                0,           brect.height, 0, 0,
                                                0,                      0, 1, 0,
                                                0,                      0, 0, 1)

    //    function translate(x, y, x) {
    //        return Qt.matrix4x4(0, 0, 0, x,
    //                            0, 0, 0, y,
    //                            0, 0, 0, z);
    //    }

    /*    property matrix4x4 reflectXZ: Qt.matrix4x4(1,  0, 0, 0,
                                               0, -1, 0, 0,
                                               0,  0, 1, 0,
                                               0,  0, 0, 1)
*/
    //   property matrix4x4 reflectXZ: Qt.matrix4x4()

    onMatrixChanged: {
        var ma = root.matrix;
        var src = [
                    [0, 0, "TL"]
                    ,[1, 0, "TR"]
                    ,[0, 1, "BL"]
                    ,[1, 1, "BR"]
                    ,[.5, .5, "C"]
                ];

        for(var i in src) {
            var v = Qt.vector4d(src[i][0], src[i][1], 0, 1);
            var r = norm(root.matrix.times(root.scaleBrect).times(v));
            markers.setProperty(i, 'mx', /*brect.x + */r.x);
            markers.setProperty(i, 'my', /*-brect.y*/ -r.y);
            console.log(root.matrix)
            console.log(i, src[i], "->", r);
        }
    }

    ListModel {
        id: markers
        ListElement { mx: 0; my: 54 }
        ListElement { mx: 64.4503; my: 36.7707 }
        ListElement { mx: 0.986511; my: 103.326 }
        ListElement { mx: 65.6525; my: 102.348 }
        ListElement { mx: 28.2108; my: 74.7752 }
        //        ListElement { mx: 0; my: 0 }
        //        ListElement { mx: 100; my: 0 }
        //        ListElement { mx: 0; my: 100 }
        //        ListElement { mx: 100; my: 100 }
        //        ListElement { mx: 50; my: 50 }
    }

    function norm(v) {
        return Qt.vector3d(v.x/v.w, v.y/v.w, v.z/v.w);
    }

    Entity {
        id: cellEntity

        //        property matrix4x4 mov: Qt.matrix4x4(1, 0, 0, 0,
        //                                             0, 1, 0, 70,
        //                                             0, 0, 1, 0,
        //                                             0, 0, 0, 1)

        Transform {
            id: transform
            //translation: root.center

            //        Square2Quad {
            //            id: square2quad
            //         }

            //matrix: root.matrix.transposed()
            //        matrix: root.mov.times(root.rotX90) // working move matrix

            matrix: root.scaledMatrix

            /*matrix: {
                var t = 200 * (timer.value % 100)/100;
                var c = Math.cos(t/20);
                var s = Math.sin(t/20);
                var n = Math.tan(t/20); console.log(t, n);
                var m = Qt.matrix4x4(1,  0,  0, 0,
                                     0,  1,  0, 0,
                                     0,  0,  1, 0,
                                     0,  0,  0, 1).times(
                            Qt.matrix4x4(40, 0,  0, 0,
                                         0, 40,  0, 0,
                                         0,  0,  1, 0,
                                         0,  0,  0, 1)
                            );
                m = sceneRoot.matrix;
                return m;
            } */

            //matrix: root.scaleBrect
            /*{
                var m = Qt.matrix4x4();
                //m = m.times(root.rot90);
                //m = m.times(root.translate(50, 50, 0));
                m = m.times(root.matrix.inverted().transposed());
                //root.matrix.times(root.translate(50, 50, 0).times(root.rotX90))
                return m;
            }*/

            //Qt.matrix4x4().rotate(90, 1, 0, 0) //fromEulerAngles(0, 0, 90)
            //rotateAround(Qt.vector3d(0, 0, 0), 90, Qt.vector3d(1, 0, 0)) * rotateAround(Qt.vector3d(0, 0, 0), 0, Qt.vector3d(1, 0, 0))
            //rotationX: 90
            //rotationY: 45 // root.rotation
            //rotation: fromAxisAndAngle(Qt.vector3d(0, 0, 1), root.rotation)
        }

        components: [transform]

        /*Marker {
            translation: Qt.vector3d(1, 1, 0)
            scale: .004
        }*/

        NodeInstantiator {
            model: ListModel {
                ListElement { mx: 0; my: 0 }
                ListElement { mx: 0; my: 1 }
                ListElement { mx: 1; my: 0 }
                ListElement { mx: 1; my: 1 }
            }
            Marker {
                id: marker
                scale: .1
                color: "yellow"
                translation: Qt.vector3d(mx, my, 0)
            }
        }
        //Marker {
        //    scale: 1
        // }
        Entity {
            id: planeEntity

            PlaneMesh {
                id: mesh
                width: 1.0
                height: 1.0
                meshResolution: Qt.size(2, 2)
            }

            NormalDiffuseSpecularMapMaterial {
                id: material
                ambient: Qt.rgba(0.2, 0.2, 0.2, 1.0)

                diffuse: "assets/lavrov.jpeg"
//                diffuse: "assets/Earth/basic0.png"
                specular: diffuse
                normal: diffuse

                //diffuse:  "assets/textures/pattern_09/diffuse.webp"
                //specular: "assets/textures/pattern_09/specular.webp"
                //normal:   "assets/textures/pattern_09/normal.webp"

                textureScale: 10.0
                shininess: 80.0
            }

            Transform {
                id: planeTransform
                // step 1
                rotationX: 90
                // step 2
                translation: Qt.vector3d(mesh.width/2, mesh.height/2, 0)
            }

            Timer {
                id: timer
                property real value: 0
                interval: 30
                running: true
                repeat: true
                onTriggered: value++
            }

            components: [ planeTransform, mesh, material ]
        }
    }

    NodeInstantiator {
        model: markers
        Marker {
            id: marker
            scale: 4
            color: "red"
            translation: Qt.vector3d(mx, my, 0)
        }
    }

    Marker {
        scale: 1
    }

    XYAxes {
        scale: 100
    }
}
