﻿import QtQuick 2.1 as QQ2
import Qt3D.Core 2.0
import Qt3D.Render 2.0
import Qt3D.Input 2.0
import Qt3D.Extras 2.0
import QtQuick.Scene3D 2.0

Entity {
    id: sceneRoot

    property matrix4x4 matrix: Qt.matrix4x4(0.299385, -0.0147783, 0, 3, -0.259615, 0.299385, 0, 54, 0, 0, 1, 0, -0.00327692, -9.36719e-5, 0, 1)
    property rect brect: Qt.rect(67, 85, 208, 203)
    property alias aspectRatio: mainCamera.aspectRatio

    // Use the renderer configuration specified in ForwardRenderer.qml
    // and render from the mainCamera
    components: [
        //                RenderSettings {
        //                    activeFrameGraph: SortedForwardRenderer {
        //                        id: renderer
        //                        camera: mainCamera
        //                    }
        //                },
        RenderSettings {
            activeFrameGraph: ForwardRenderer {
                // clearColor: Qt.rgba(1, 1, 1, 1)
                camera: mainCamera
            }
        },

        // Event Source will be set by the Qt3DQuickWindow
        InputSettings { }
    ]

    Camera {
        id: mainCamera

        projectionType: CameraLens.PerspectiveProjection
        fieldOfView: 22.5
        aspectRatio: _window.width / _window.height
        onAspectRatioChanged: console.log( "aspectRati0 = " + aspectRatio )
        nearPlane:   0.1
        farPlane:    2000.0
        viewCenter: Qt.vector3d(0, 0, 0)
        //upVector: Qt.vector3d( 0.0, 1.0, 0.0 )
        //position: Qt.vector3d( 0.0, 3.5, 25.0 )

        // XZ rects major
        //upVector: Qt.vector3d( 1.0, 0.0, 0.0 )
        //position: Qt.vector3d( 0.0, 430., 0 )

        // XY rects major
        upVector: Qt.vector3d( 0.0, 1.0, 0.0 )
        position: Qt.vector3d( 0.0, 0, 900.0 )
    }

    //            BasicCamera {
    //                id: mainCamera
    //                position: Qt.vector3d( 0.0, 0.0, 15.0 )
    //            }


    //            FirstPersonCameraController { camera: mainCamera }

    /*    PhongMaterial {
        id: redAdsMaterial
        ambient: Qt.rgba( 0.2, 0.0, 0.0, 1.0 )
        diffuse: Qt.rgba( 0.8, 0.0, 0.0, 1.0 )
    }
*/
    //            QQ2.ListModel {
    //                id: cellsModel
    //                /*                QQ2.ListElement { centerY: 1 }
    //                QQ2.ListElement { centerY: 2 }
    //                QQ2.ListElement { centerY: 3 }
    //*/
    //                QQ2.Component.onCompleted: {
    //                    var maxLevel = 4;
    //                    for(var level=1; level<maxLevel; level++) {
    //                        var maxX = Math.floor(2*Math.PI*level);
    //                        var phi0 = 360/maxX
    //                        for(var i=0; i<maxX; i++) {
    //                            cellsModel.append({role_r: level+.5, role_phi: i * phi0});
    //                        }
    //                    }
    //                }

    //            }

    //            NodeInstantiator {
    //                model: cellsModel
    //                //Cell {
    //                //    r: role_r
    //                //    phi: role_phi
    //                //}
    //            }


    //Cell {
    //    matrix: sqt.matrix
    //    brect: sqt.brect
    //}
    Cell {
        matrix: sceneRoot.matrix
        brect: sceneRoot.brect
        //center: Qt.vector3d(1, 0, 0)
    }
}
