import QtQuick 2.7

import Qt3D.Core 2.0
import Qt3D.Render 2.0
import Qt3D.Input 2.0
import Qt3D.Extras 2.0
import QtQuick.Scene3D 2.0

Entity {
    id: root

    property vector3d translation: Qt.vector3d(0, 0, 0)
    property color color: "white"
    property real scale: 1

    SphereMesh {
        id: mesh
        radius: .5
        rings: 10
        slices: 10
    }

    PhongMaterial {
        id: mat
        diffuse: root.color
        specular: root.color
    }

    Transform {
        id: trans
        scale: root.scale
        translation: root.translation
    }

    WireframeMainMaterial {
        id: wfm
    }

    components: [mesh, wfm, trans]
}
