import QtQuick 2.0

Rectangle {
    id: root
    property vector2d pos
    property alias text: txt.text
    width: 20
    height: width
    radius: width/2
    color: "yellow"
    x: pos.x
    y: pos.y

    signal moved
    onXChanged: moved()
    onYChanged: moved()

    property int cx: x + width/2
    property int cy: y + height/2

    Text {
        id: txt
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.margins: 4
        font.pixelSize: 9
        color: root.color
    }

    MouseArea {
        anchors.fill: parent
        anchors.margins: -20
        enabled: root.text.length == 0
        drag.target: parent
        drag.axis: Drag.XandYAxis
    }

}
