import QtQuick 2.2
import Qt3D.Core 2.0
import Qt3D.Render 2.0
import Qt3D.Input 2.0
import Qt3D.Extras 2.0
import QtQuick.Scene3D 2.0

QtObject {
    function preRectToQuad(X, Y, W, H, x1a, y1a, x2a, y2a, x3a, y3a, x4a, y4a) {
        function boundingBox(x1a, y1a, x2a, y2a, x3a, y3a, x4a, y4a) {
            var xmin = Math.min(Math.min(Math.min(x1a, x2a), x3a), x4a);
            var ymin = Math.min(Math.min(Math.min(y1a, y2a), y3a), y4a);
            var xmax = Math.max(Math.max(Math.max(x1a, x2a), x3a), x4a);
            var ymax = Math.max(Math.max(Math.max(y1a, y2a), y3a), y4a);
            var x = xmin;
            var y = ymin;
            var width = xmax - xmin;
            var height = ymax - ymin;
            return Qt.rect(x, y, width, height);
        }

        var bb = boundingBox(x1a, y1a, x2a, y2a, x3a, y3a, x4a, y4a);

        //console.log("####", X, Y, W, H, x1a, y1a, x2a, y2a, x3a, y3a, x4a, y4a);
        //console.log("#", bb);

        var m = rectToQuad1(0, 0, //bb.x, bb.y,
                            bb.width, bb.height,
                            x1a-bb.x, y1a-bb.y,
                            x2a-bb.x, y2a-bb.y,
                            x3a-bb.x, y3a-bb.y,
                            x4a-bb.x, y4a-bb.y);
        return [bb, m];
    }

    function rectToQuad1(X, Y, W, H, x1a, y1a, x2a, y2a, x3a, y3a, x4a, y4a) {
        //console.log("~~~~", X, Y, W, H, x1a, y1a, x2a, y2a, x3a, y3a, x4a, y4a);

        var y21 = y2a - y1a;
        var y32 = y3a - y2a;
        var y43 = y4a - y3a;
        var y14 = y1a - y4a;
        var y31 = y3a - y1a;
        var y42 = y4a - y2a;

        var a = -H*(x2a*x3a*y14 + x2a*x4a*y31 - x1a*x4a*y32 + x1a*x3a*y42);
        var b = W*(x2a*x3a*y14 + x3a*x4a*y21 + x1a*x4a*y32 + x1a*x2a*y43);
        var c = H*X*(x2a*x3a*y14 + x2a*x4a*y31 - x1a*x4a*y32 + x1a*x3a*y42) - H*W*x1a*(x4a*y32 - x3a*y42 + x2a*y43) - W*Y*(x2a*x3a*y14 + x3a*x4a*y21 + x1a*x4a*y32 + x1a*x2a*y43);

        var d = H*(-x4a*y21*y3a + x2a*y1a*y43 - x1a*y2a*y43 - x3a*y1a*y4a + x3a*y2a*y4a);
        var e = W*(x4a*y2a*y31 - x3a*y1a*y42 - x2a*y31*y4a + x1a*y3a*y42);
        var f = -(W*(x4a*(Y*y2a*y31 + H*y1a*y32) - x3a*(H + Y)*y1a*y42 + H*x2a*y1a*y43 + x2a*Y*(y1a - y3a)*y4a + x1a*Y*y3a*(-y2a + y4a)) - H*X*(x4a*y21*y3a - x2a*y1a*y43 + x3a*(y1a - y2a)*y4a + x1a*y2a*(-y3a + y4a)));

        var g = H*(x3a*y21 - x4a*y21 + (-x1a + x2a)*y43);
        var h = W*(-x2a*y31 + x4a*y31 + (x1a - x3a)*y42);
        var i = W*Y*(x2a*y31 - x4a*y31 - x1a*y42 + x3a*y42) + H*(X*(-(x3a*y21) + x4a*y21 + x1a*y43 - x2a*y43) + W*(-(x3a*y2a) + x4a*y2a + x2a*y3a - x4a*y3a - x2a*y4a + x3a*y4a));

        var kEpsilon = 0.0001;

        if(Math.abs(i) < kEpsilon)
        {
            i = kEpsilon* (i > 0 ? 1.0 : -1.0);
        }

        // XY, Apple
//        return Qt.matrix4x4(a/i, d/i,  0, g/i,
//                            b/i, e/i,  0, h/i,
//                            0,   0,  1,   0,
//                            c/i,  f/i, 0,  1.0)

        // Qt
        return Qt.matrix4x4(a/i, b/i,  0, c/i,
                            d/i, e/i,  0, f/i,
                              0,   0,  1,   0,
                            g/i,  h/i, 0,  1.0)
    }
}
