import QtQuick 2.7

import Qt3D.Core 2.0
import Qt3D.Render 2.0
import Qt3D.Input 2.0
import Qt3D.Extras 2.0
import QtQuick.Scene3D 2.0

Entity {
    id: root

    property real scale: 1

    Entity {
        id: xAxis
        CylinderMesh {
            id: xAxisMesh
            radius: 1
            length: root.scale
            rings: 5
            slices: 10
        }
        PhongMaterial {
            id: xAxisMat
            diffuse: "red"
            specular: "red"
        }
        Transform {
            id: xAxisTransform
            translation: Qt.vector3d(xAxisMesh.length/2, 0, 0)
            rotationZ: 90
        }
        components: [xAxisMesh, xAxisMat, xAxisTransform]
    }
    Entity {
        id: yAxis
        CylinderMesh {
            id: yAxisMesh
            radius: 1
            length: root.scale
            rings: 5
            slices: 10
        }
        PhongMaterial {
            id: yAxisMat
            diffuse: "lime"
            specular: "lime"
        }
        Transform {
            id: yAxisTransform
            translation: Qt.vector3d(0, yAxisMesh.length/2, 0)
        }
        components: [yAxisMesh, yAxisMat, yAxisTransform]
    }
}
